ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.5 by root, Thu Mar 8 15:19:08 2007 UTC vs.
Revision 1.96 by root, Wed Oct 6 00:28:15 2010 UTC

1#!@PERL@ 1#!@PERL@
2 2
3use strict; 3#
4# This file is part of Deliantra, the Roguelike Realtime MMORPG.
5#
6# Copyright (©) 2007,2008,2009 Marc Alexander Lehmann / Robin Redeker / the Deliantra team
7#
8# Deliantra is free software: you can redistribute it and/or modify it under
9# the terms of the Affero GNU General Public License as published by the
10# Free Software Foundation, either version 3 of the License, or (at your
11# option) any later version.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the Affero GNU General Public License
19# and the GNU General Public License along with this program. If not, see
20# <http://www.gnu.org/licenses/>.
21#
22# The authors can be reached via e-mail to <support@deliantra.net>
23#
24
25use common::sense;
4 26
5my $prefix = "@prefix@"; 27my $prefix = "@prefix@";
6my $exec_prefix = "@exec_prefix@"; 28my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 29my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 30my $DATADIR = "@datadir@/@PACKAGE@";
9 31
10my $CONVERT = "@CONVERT@"; 32my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 33#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 34my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 35my $RSYNC = "@RSYNC@";
36my $PNGNQ = "@PNGNQ@";
14 37
15use Getopt::Long; 38use Getopt::Long;
39use File::Temp;
40use POSIX ();
41use Carp;
42
16use Coro::Event; 43use Coro::EV;
17use AnyEvent; 44use AnyEvent;
45use YAML::XS ();
46use JSON::XS ();
18use IO::AIO (); 47use IO::AIO ();
19use File::Temp; 48use Digest::MD5 ();
20use Crossfire; 49
21use Coro; 50use Coro 5.12;
22use Coro::AIO; 51use Coro::AIO;
23use POSIX (); 52use Coro::Util;
53use Coro::Channel;
54use Coro::Storable; $Storable::canonical = 1;
55
56use Deliantra;
57
58$SIG{QUIT} = sub { Carp::cluck "QUIT" };
24 59
25sub usage { 60sub usage {
26 warn <<EOF; 61 warn <<EOF;
27Usage: cfutil [-v] [-q] [--force] [--cache] 62Usage: cfutil [-v] [-q] [--force] [--cache]
28 [--install-arch path] 63 [--install-arch path]
39my $VERBOSE = 1; 74my $VERBOSE = 1;
40my $CACHE = 0; 75my $CACHE = 0;
41my $FORCE; 76my $FORCE;
42my $TMPDIR = "/tmp/cfutil$$~"; 77my $TMPDIR = "/tmp/cfutil$$~";
43my $TMPFILE = "aaaa0"; 78my $TMPFILE = "aaaa0";
79my @COMMIT;
80
81our %COLOR = (
82 black => 0,
83 white => 1,
84 navy => 2,
85 red => 3,
86 orange => 4,
87 blue => 5,
88 darkorange => 6,
89 green => 7,
90 lightgreen => 8,
91 grey => 9,
92 brown => 10,
93 gold => 11,
94 tan => 12,
95);
44 96
45END { system "rm", "-rf", $TMPDIR } 97END { system "rm", "-rf", $TMPDIR }
46 98
47Event->signal (signal => "INT", cb => sub { exit 1 }); 99my $s_INT = EV::signal INT => sub { exit 1 };
48Event->signal (signal => "TERM", cb => sub { exit 1 }); 100my $s_TERM = EV::signal TERM => sub { exit 1 };
101
102our %hash;
103
104# here we could try to avoid collisions and reduce chksum size further
105sub make_hash($\$\$;$) {
106 my ($id, $dataref, $hashref, $clen) = @_;
107
108 my $hash = substr +(Digest::MD5::md5 $$dataref), 0, $clen || 4;
109
110 if (exists $hash{$hash}) {
111 # hash collision, but some files are simply identical
112 if (${$hash{$hash}[1]} ne $$dataref) {
113 warn "hash collision $hash{$hash}[0] vs. $id\n";
114 exit 1;
115 } else {
116 print "$hash{$hash}[0] and $id are identical (which is fine).\n" if $VERBOSE >= 3;
117 }
118 }
119 $hash{$hash} = [$id, $dataref, $hashref];
120
121 $$hashref = $hash;
122}
49 123
50mkdir $TMPDIR, 0700 124mkdir $TMPDIR, 0700
51 or die "$TMPDIR: $!"; 125 or die "$TMPDIR: $!";
52 126
53sub fork_sub(&) { 127sub fork_sub(&) {
66} 140}
67 141
68sub inst_maps($) { 142sub inst_maps($) {
69 my (undef, $path) = @_; 143 my (undef, $path) = @_;
70 144
71 print "installing '$path' to '$DATADIR/maps'\n\n"; 145 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
72 146
73 if (!-f "$path/regions") { 147 if (!-f "$path/regions") {
74 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 148 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
75 exit 1 unless $FORCE; 149 exit 1 unless $FORCE;
76 } 150 }
77 151
78 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"; 152 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
153 "$path/.", "$DATADIR/maps/.",
154 "--exclude", "CVS", "--exclude", "/world-precomposed",
155 "--delete", "--delete-excluded"
156 and die "map installation failed.\n";
157
158 print "maps installed successfully.\n";
79} 159}
80 160
161our @WALL_SUFFIX = qw(⬤ ╹ ╺ ┗ ╻ ┃ ┏ ┣ ╸ ┛ ━ ┻ ┓ ┫ ┳ ╋);
162
163sub autoglyph {
164 my ($stem, $face) = @_;
165
166 if ($stem =~ /^wall\/|Nimwall/) {
167 return $WALL_SUFFIX[hex $1]
168 if $stem =~ /(_[0-9A-F]).x11/;
169
170 "+"
171
172 } elsif ($stem =~ /^monster.*\/(.)/) {
173 $1
174
175 } elsif ($stem =~ /^floor\/|^ground\/|Nimfloor/) {
176 "."
177
178 } elsif ($stem =~ /^player\//) {
179 "\@"
180
181 } else {
182 substr $stem, 0, 1
183 }
184}
185
81{ 186{
82 our @PNG; 187 our %ANIMINFO;
188 our %FACEINFO;
189 our %RESOURCE;
83 our @ARC; 190 our @ARC;
191 our %ARC;
192 our $TRS;
84 our $NFILE; 193 our $NFILE;
85 our @FACE;
86 our $ANIM; 194 our $PATH;
87 195
88 our (@png, @trs, @arc); # files we are interested in 196 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
89 197
198 our $c_arc = new Coro::Channel;
199 our $c_trs = new Coro::Channel;
200 our $c_res = new Coro::Channel;
201
202 our @c_png;
203
90 sub commit_png { 204 sub commit_png($$$$) {
91 my ($name, $data) = @_; 205 my ($stem, $name, $data, $T) = @_;
92 206
93 push @PNG, [$name => $data]; 207 $FACEINFO{$name}{"stem"} = substr $stem, 1 + length $PATH;
208 $FACEINFO{$name}{"data$T"} = $data;
94 } 209 }
95 210
96 sub process_png { 211 sub process_png {
97 while (@png) { 212 while (@c_png) {
98 my $path = pop @png; 213 my ($path, $delete) = @{pop @c_png};
99 214
100 my $png; 215 my $png;
101 aio_lstat $path; 216 aio_lstat $path;
102 my ($size, $mtime) = (stat _)[7,9]; 217 my ($size, $mtime) = (stat _)[7,9];
103 218
104 if (0 > aio_load $path, $png) { 219 if (0 > aio_load $path, $png) {
105 warn "$path: $!, skipping.\n"; 220 warn "$path: $!, skipping.\n";
106 next; 221 next;
107 } 222 }
108 223
109 # quickly extratc width and height of the (necessarily PNG) image 224 my $stem = $path;
110 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 225 my $T;
111 warn "$path: not a recongized png file, skipping.\n";
112 next;
113 }
114 226
115 my ($w, $h) = unpack "NN", $1; 227 if ($stem =~ s/\.32x32\.png~?$//) {
116
117 (my $face = $path) =~ s/^.*\///;
118 my $T = 32; 228 $T = 32;
119 229 } elsif ($stem =~ s/\.64x64\.png~?$//) {
120 unless ($face =~ s/\.base\.(...)\.png$/.$1/) { 230 $T = 64;
231 } else {
121 warn "$path: weird filename, skipping.\n"; 232 warn "$path: weird filename, skipping.\n";
122 next; 233 next;
123 } 234 }
235
236 # quickly extract width and height of the (necessarily PNG) image
237 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
238 warn "$path: not a recognized png file, skipping.\n";
239 next;
240 }
241
242 my ($w, $h) = unpack "NN", $1;
124 243
125 if ($w < $T || $h < $T) { 244 if ($w < $T || $h < $T) {
126 warn "$path: too small ($w $h), skipping.\n"; 245 warn "$path: too small ($w $h), skipping.\n";
127 next; 246 next;
128 } 247 }
130 if ($w % $T || $h % $T) { 249 if ($w % $T || $h % $T) {
131 warn "$path: weird png size ($w $h), skipping.\n"; 250 warn "$path: weird png size ($w $h), skipping.\n";
132 next; 251 next;
133 } 252 }
134 253
254 (my $base = $stem) =~ s/^.*\///;
255
256 my $fi = $FACEINFO{$base};
257 unless ($fi) {
258 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
259 #next;
260 }
261
262 my $arc = $fi->{arc} || { };
263
264 unless ($path =~ /~$/) {
265 # possibly enlarge
266 if (0 > aio_stat "$stem.64x64.png") {
267 my $other = "$stem.64x64.png~";
268
269 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
270 fork_sub {
271 my $CROP;
272 my $SRC = "png:\Q$path\E";
273
274 my $is_floor = $arc->{is_floor};
275 my $is_wall = 0;
276
277 my ($wall_pfx, $wall_dir, $wall_sfx);
278
279 if (
280 !$is_floor
281 && !$arc->{alive}
282 && $arc->{move_block} eq "all"
283 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
284 ) {
285 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
286
287 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
288 $is_wall = 1;
289 }
290 }
291
292 if ($is_wall || $is_floor) {
293 # add a 4px border and add other images around it
294 $CROP = "-shave 8x8 +repage";
295
296 $w += 8;
297 $h += 8;
298
299 $SRC = "-size ${w}x${h} xc:transparent";
300 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
301
302 # 8 surrounding images
303 for (
304 # x y b r0 r1
305 [-1, -1, 0, 6],
306 [ 0, -1, 1, 10, 14],
307 [+1, -1, 0, 12],
308
309 [-1, 0, 8, 5, 7],
310 #
311 [+1, 0, 2, 5, 13],
312
313 [-1, +1, 0, 3],
314 [ 0, +1, 4, 10, 11],
315 [+1, +1, 0, 9],
316 ) {
317 my ($x, $y, $d, $r0, $r1) = @$_;
318
319 my $tile = $is_floor ? $path
320 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
321 : die;
322
323 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
324 "\Q$tile",
325 $x * ($w - 8) + 4,
326 $y * ($h - 8) + 4;
327 }
328 }
329
330 system "convert -depth 8 $SRC rgba:-"
331 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
332 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
333 and die "convert/cfhq2xa pipeline error: status $? ($!)";
334 system $OPTIPNG, "-i0", "-q", "$other~";
335 die "$other~ has zero size, aborting." unless -s "$other~";
336 rename "$other~", $other;
337 };
338 }
339
340 push @c_png, [$other, !$CACHE];
341 }
342
343 # possibly scale down
344 if (0 > aio_stat "$stem.32x32.png") {
345 my $other = "$stem.32x32.png~";
346
347 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
348 fork_sub {
349 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
350 system $OPTIPNG, "-i0", "-q", "$other~";
351
352 # reduce smoothfaces >10000 bytes
353 # obsolete, no longer required
354 if (0 && $stem =~ /_S\./ && (-s "$other~") > 10000) {
355 my $ncolor = 256;
356 while () {
357 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
358 system $OPTIPNG, "-i0", "-q", "$other~~";
359 last if 10000 > -s "$other~~";
360 $ncolor = int $ncolor * 0.9;
361 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
362 }
363
364 printf "reduced %s from %d to %d bytes using %d colours.\n",
365 $other, -s "$other~", -s "$other~~", $ncolor
366 if $VERBOSE >= 2;
367 rename "$other~~", "$other~";
368 }
369
370 die "$other~ has zero size, aborting." unless -s "$other~";
371 rename "$other~", $other;
372 };
373 }
374
375 #warn "scaled down $path to $other\n";#d#
376 push @c_png, [$other, !$CACHE];
377 }
378 }
379
380 (my $face = $stem) =~ s/^.*\///;
381
382 # split all bigfaces, but avoid smoothfaces (*_S)
135 if (($w > $T || $h > $T) && $face !~ /_S\./) { 383 if (($w > $T || $h > $T) && $face !~ /_S\./) {
136 # split 384 # split
137 my @tile; 385 my @tile;
138 for my $x (0 .. (int $w / $T) - 1) { 386 for my $x (0 .. (int $w / $T) - 1) {
139 for my $y (0 .. (int $h / $T) - 1) { 387 for my $y (0 .. (int $h / $T) - 1) {
147 my @todo = grep { $_->[3] <= $mtime } @tile; 395 my @todo = grep { $_->[3] <= $mtime } @tile;
148 if (@todo) { 396 if (@todo) {
149 fork_sub { 397 fork_sub {
150 open my $convert, "|-", $CONVERT, 398 open my $convert, "|-", $CONVERT,
151 "png:-", 399 "png:-",
152 -negate,#d#
153 (map { 400 (map {
154 ( 401 (
155 "(", 402 "(",
156 "+clone", 403 "+clone",
157 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 404 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
405 "+repage",
406 -quality => "00",
158 -write => "png:$_->[2]~", 407 -write => "png32:$_->[2]~",
159 "+delete", 408 "+delete",
160 ")", 409 ")",
161 ) 410 )
162 } @todo), 411 } @todo),
163 "null:"; 412 "null:";
167 close $convert; 416 close $convert;
168 417
169 # pass 2, optimise, and rename 418 # pass 2, optimise, and rename
170 for (@todo) { 419 for (@todo) {
171 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 420 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
421 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
172 rename "$_->[2]~", $_->[2]; 422 rename "$_->[2]~", $_->[2];
173 } 423 }
174 }; 424 };
175 } 425 }
176 426
180 430
181 if (0 > aio_load $file, $tile) { 431 if (0 > aio_load $file, $tile) {
182 die "$path: unable to read tile +$x+$y, aborting.\n"; 432 die "$path: unable to read tile +$x+$y, aborting.\n";
183 } 433 }
184 IO::AIO::aio_unlink $file unless $CACHE; 434 IO::AIO::aio_unlink $file unless $CACHE;
185 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 435 commit_png $stem, $x|$y ? "$face+$x+$y" : $face, $tile, $T;
186 } 436 }
187 } else { 437 } else {
188 # use as-is (either small, use smooth) 438 # use as-is (either small, use smooth)
189 commit_png $face, $png; 439 commit_png $stem, $face, $png, $T;
190 } 440 }
441
442 aio_unlink $path if $delete;
191 } 443 }
192 } 444 }
193 445
194 sub process_arc { 446 sub process_arc {
195 while (@arc) { 447 while (my $job = $c_arc->get) {
196 my ($dir, $file) = @{pop @arc}; 448 my ($dir, $file) = @$job;
197 449
198 my $arc; 450 my $arc;
199 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 451 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
200 452
201 my $arc = read_arch "$dir/$file"; 453 my $arc = read_arch "$dir/$file";
202 for my $o (values %$arc) { 454 for my $o (values %$arc) {
203 push @ARC, $o; 455 push @ARC, $o;
456 for (my $m = $o; $m; $m = $m->{more}) {
457 $ARC{$m->{_name}} = $m;
458 }
459
460 $o->{editor_folder} ||= "\x00$dir"; # horrible kludge
461
462 my $visibility = delete $o->{visibility};
463 my $magicmap = delete $o->{magicmap};
464 my $glyph = delete $o->{glyph};
465
466 # find upper left corner :/
467 # omg, this is sooo broken
204 my ($dx, $dy); 468 my ($dx, $dy);
205 # omg, this is sooo broken
206 for (my $o = $o; $o; $o = $o->{more}) { 469 for (my $o = $o; $o; $o = $o->{more}) {
207 $dx = $o->{x} if $o->{x} < $dx; 470 $dx = $o->{x} if $o->{x} < $dx;
208 $dy = $o->{y} if $o->{y} < $dy; 471 $dy = $o->{y} if $o->{y} < $dy;
209 } 472 }
473
210 for (my $o = $o; $o; $o = $o->{more}) { 474 for (my $o = $o; $o; $o = $o->{more}) {
211 my $x = $o->{x} - $dx; 475 my $x = $o->{x} - $dx;
212 my $y = $o->{y} - $dy; 476 my $y = $o->{y} - $dy;
477
478 my $ext = $x|$y ? "+$x+$y" : "";
479
480 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
481
482 $visibility = delete $o->{visibility} if exists $o->{visibility};
483 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
484 $glyph = delete $o->{glyph} if exists $o->{glyph};
485
486 my $anim = delete $o->{anim};
487
213 if ($x|$y) { 488 if ($anim) {
214 $_ .= "+$x+$y" for $o->{face}, @{$o->{anim} || []}; 489 # possibly add $ext to the animation name to avoid
490 # the need to specify archnames for all parts
491 # of a multipart archetype.
492 $o->{animation} = "$o->{_name}";
493 my $facings = 1;
494 my @frames;
495
496 for (@$anim) {
497 if (/^facings\s+(\d+)/) {
498 $facings = $1*1;
499 } elsif (/^blank.x11$|^empty.x11$/) {
500 push @frames, $_;
501 } else {
502 push @frames, "$_$ext";
503 }
504 }
505
506 $ANIMINFO{$o->{animation}} = {
507 facings => $facings,
508 frames => \@frames,
509 };
215 } 510 }
511
512 for ($o->{face} || (), @{$anim || []}) {
513 next if /^facings\s/;
514
515 my $face = $_;
516 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
517
518 my $info = $FACEINFO{$face} ||= { };
519 $info->{arc} = $o;
520
521 next if $face =~ /^blank.x11$|^empty.x11$/;
522
523 $info->{visibility} = $visibility if defined $visibility;
524 $info->{magicmap} = $magicmap if defined $magicmap;
525 $info->{glyph} = $glyph if defined $glyph;
216 } 526 }
527
217 if (my $anim = delete $o->{anim}) { 528 if (my $smooth = delete $o->{smoothface}) {
218 $o->{animation} = $o->{_name}; 529 my %kv = split /\s+/, $smooth;
219 $ANIM .= join "", map "$_\n", 530 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
220 "anim $o->{_name}", 531 while (my ($face, $smooth) = each %kv) {
221 @$anim, 532 $FACEINFO{$smooth}{arc} = $o;
222 "mina"; 533
534 $FACEINFO{$face}{smooth} = $smooth;
535 $FACEINFO{$face}{smoothlevel} = $level;
536 }
537 }
223 } 538 }
224 } 539 }
225 } 540 }
226 } 541 }
227 542
228 sub process_trs { 543 sub process_trs {
229 while (@trs) { 544 while (my $job = $c_trs->get) {
230 my ($dir, $file) = @{pop @trs}; 545 my ($dir, $file) = @$job;
546 my $path = "$dir/$file";
547
548 my $trs;
549 if (0 > aio_load $path, $trs) {
550 warn "$path: $!, skipping.\n";
551 next;
552 }
553
554 $TRS .= $trs;
555 }
556 }
557
558 my %FILECACHE;
559
560 sub load_cached($;$) {
561 unless (exists $FILECACHE{$_[0]}) {
562 my $data;
563 if (0 < aio_load $_[0], $data) {
564 if ($_[1]) {
565 $data = eval { $_[1]->($data) };
566 warn "$_[0]: $@" if $@;
567 }
568 }
569
570 $FILECACHE{$_[0]} = $data;
571 }
572
573 $FILECACHE{$_[0]}
574 }
575
576 sub process_res {
577 while (my $job = $c_res->get) {
578 my ($dir, $file, $type) = @$job;
579
580 my $data;
581 aio_load "$dir/$file", $data;
582
583 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
584
585 utf8::decode $dir;
586 utf8::decode $file;
587
588 # a meta file for resources is now mandatory
589 unless (exists $meta->{$file}) {
590 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
591 next;
592 }
593
594 $meta = {
595 %{ $meta->{"" } || {} },
596 %{ $meta->{$file} || {} },
597 };
598
599 if ($meta->{license} =~ s/^#//) {
600 $meta->{license} = ({
601 "pd" => "Public Domain",
602 "gpl" => "GNU General Public License, version 3.0 or any later",
603 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
604 "cc/by/2.1" => "Licensed under Creative Commons Attribution 2.1 http://creativecommons.org/licenses/by/2.1/",
605 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
606 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
607 })->{$meta->{license}}
608 || warn "$dir/$file: license tag '$meta->{license}' not found.";
609 }
610
611 if (!exists $meta->{author} && $meta->{source} =~ m%^http://www.jamendo.com/en/artist/(.*)$%) {
612 ($meta->{author} = $1) =~ s/_/ /g;
613 }
614
615 $file =~ s/\.res$//;
616 $file =~ s/\.(ogg|wav|jpg|png)$//;
617
618 substr $dir, 0, 1 + length $PATH, "";
619
620 if (my $filter = $meta->{cfutil_filter}) {
621 if ($filter eq "yaml2json") {
622 $data = JSON::XS::encode_json YAML::XS::Load $data;
623 } elsif ($filter eq "json2json") {
624 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
625 } elsif ($filter eq "perl2json") {
626 $data = eval $data; die if $@;
627 $data = JSON::XS::encode_json $data;
628 } else {
629 warn "$dir/$file: unknown filter $filter, skipping\n";
630 }
631 }
632
633 $RESOURCE{"$dir/$file"} = {
634 type => (exists $meta->{type} ? delete $meta->{type} : $type),
635 data => $data,
636 %$meta ? (meta => $meta) : (),
637 };
231 } 638 }
232 } 639 }
233 640
234 sub find_files; 641 sub find_files;
235 sub find_files { 642 sub find_files {
238 IO::AIO::aioreq_pri 4; 645 IO::AIO::aioreq_pri 4;
239 IO::AIO::aio_scandir $path, 4, sub { 646 IO::AIO::aio_scandir $path, 4, sub {
240 my ($dirs, $nondirs) = @_; 647 my ($dirs, $nondirs) = @_;
241 648
242 find_files "$path/$_" 649 find_files "$path/$_"
243 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 650 for grep $_ !~ /^(?:CVS|dev|\..*)$/, @$dirs;
651
652 my $dir = $path;
653 substr $dir, 0, 1 + length $PATH, "";
244 654
245 for my $file (@$nondirs) { 655 for my $file (@$nondirs) {
656 if ($dir =~ /^music(?:\/|$)/) {
657 $c_res->put ([$path, $file, 3]) # FT_MUSIC
658 if $file =~ /\.(ogg)$/;
659
660 } elsif ($dir =~ /^sound(?:\/|$)/) {
661 $c_res->put ([$path, $file, 5]) # FT_SOUND
662 if $file =~ /\.(wav|ogg)$/;
663
664 } elsif ($dir =~ /^res(?:\/|$)/) {
665 if ($file =~ /\.(jpg|png)$/) {
666 $c_res->put ([$path, $file, 0]) # FT_FACE
667 } elsif ($file =~ /\.(res)$/) {
668 $c_res->put ([$path, $file, 6]) # FT_RSRC
669 } else {
670 $c_res->put ([$path, $file, undef]);
671 }
672
246 if ($file =~ /\.png$/) { 673 } elsif ($file =~ /\.png$/) {
247 push @png, "$path/$file"; 674 push @c_png, ["$path/$file", 0];
675
248 } elsif ($file =~ /\.trs$/) { 676 } elsif ($file =~ /\.trs$/) {
249 push @trs, [$path, $file]; 677 $c_trs->put ([$path, $file]);
678
250 } elsif ($file =~ /\.arc$/) { 679 } elsif ($file =~ /\.arc$/) {
251 push @arc, [$path, $file]; 680 $c_arc->put ([$path, $file]);
681
252 } else { 682 } else {
253 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 683 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
254 } 684 }
255 } 685 }
256 }; 686 };
687 }
688
689 sub generate_plurals {
690# use Lingua::EN::Inflect ();
691# Lingua::EN::Inflect::classical;
692# Lingua::EN::Inflect::def_noun '(.*)staff' => '$1staves'; # policy
693# Lingua::EN::Inflect::def_noun '(.*)boots' => '$1boots'; # hack
694#
695# for my $a (@ARC) {
696# my $name = $a->{name} || $a->{_name};
697#
698# next unless $a->{name_pl};
699# next if $a->{invisible};
700# next if $a->{is_floor};
701# next if $a->{no_pick};
702#
703# my $test = Lingua::EN::Inflect::PL_N_eq $name, Lingua::EN::Inflect::PL $name;
704# my $pl = $test =~ /^(?:eq|p:.)$/
705# ? $name
706# : Lingua::EN::Inflect::PL $name;
707#
708# if ($pl ne $a->{name_pl}) {
709# warn "$a->{_name}: plural differs, $pl vs $a->{name_pl}\n";
710# }
711# }
257 } 712 }
258 713
259 sub inst_arch($) { 714 sub inst_arch($) {
260 my (undef, $path) = @_; 715 my (undef, $path) = @_;
261 716
717 $PATH = $path;
718
719 print "\n",
262 print "installing '$path' to '$DATADIR'\n\n"; 720 "Installing '$path' to '$DATADIR'\n",
721 "\n",
722 "This can take a long time if you run this\n",
723 "for the first time or do not use --cache.\n",
724 "\n",
725 "Unless you run verbosely, all following warning\n",
726 "or error messages indicate serious problems.\n",
727 "\n";
263 728
264 if (!-d "$path/treasures") { 729 if (!-d "$path/treasures") {
265 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 730 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
266 exit 1 unless $FORCE; 731 exit 1 unless $FORCE;
267 } 732 }
268 733
734 print "scanning files...\n" if $VERBOSE;
735
269 find_files $path; 736 find_files $path;
737
738 my @a_arc = map +(async \&process_arc), 1..2;
739 my @a_res = map +(async \&process_res), 1..2;
740 my @a_trs = map +(async \&process_trs), 1..2;
741
270 IO::AIO::flush; 742 IO::AIO::flush;
271 743
272 $_->join for ( 744 $c_res->shutdown;
273 (async \&process_png), (async \&process_png), 745 $c_arc->shutdown;
274 (async \&process_trs), (async \&process_trs), 746 $c_trs->shutdown;
275 (async \&process_arc), (async \&process_arc),
276 );
277 747
748 print "start file scan, arc, res processing...\n" if $VERBOSE;
749
750 $_->join for @a_arc; # need to parse all archetypes before png processing
751
752 print "end arc, start png processing...\n" if $VERBOSE;
753
754 # eight png crunchers work fine for my 4x smp machine
755 my @a_png = map +(async \&process_png), 1..8;
756
757 $_->join for (@a_trs, @a_res, @a_png);
758
759 print "scanning done, processing results...\n" if $VERBOSE;
278 { 760 {
279 open my $fh, ">:utf8", "$DATADIR/animations~" 761 # remove path prefix from editor_folder
280 or die "$DATADIR/animations~: $!"; 762 $_->{editor_folder} =~ /^\x00/
281 print $fh $ANIM; 763 and substr $_->{editor_folder}, 0, 2 + length $path, ""
764 for values %ARC;
765
766 print "resolving inheritance tree...\n" if $VERBOSE;
767 # resolve inherit
768 while () {
769 my $progress;
770 my $loop;
771
772 for my $o (values %ARC) {
773 for my $other (split /,/, $o->{inherit}) {
774 if (my $s = $ARC{$other}) {
775 if ($s->{inherit}) {
776 $loop = $s;
777 } else {
778 delete $o->{inherit};
779 my %s = %$s;
780 delete @s{qw(_name more name name_pl)};
781 %$o = ( %s, %$o );
782 ++$progress;
783 }
784 } else {
785 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
786 delete $ARC{$o->{_name}};
787 }
788 }
789 }
790
791 unless ($progress) {
792 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
793 if $loop;
794
795 last;
796 }
282 } 797 }
283 798
284 { 799 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
800 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
801
802 print "generating plurals...\n" if $VERBOSE;
803 generate_plurals;
804
805 printf "writing %d archetypes...\n", scalar @ARC if $VERBOSE;
285 open my $fh, ">:utf8", "$DATADIR/archetypes~" 806 open my $fh, ">:utf8", "$DATADIR/archetypes~"
286 or die "$DATADIR/archetypes~: $!"; 807 or die "$DATADIR/archetypes~: $!";
287 print $fh Crossfire::archlist_to_string \@ARC; 808 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
288 } 809 }
289
290 @PNG = sort { $a->[0] cmp $b->[0] } @PNG;
291 810
292 { 811 {
812 printf "writing treasures (%d octets)...\n", length $TRS if $VERBOSE;
813 open my $fh, ">:utf8", "$DATADIR/treasures~"
814 or die "$DATADIR/treasures~: $!";
815 print $fh $TRS;
816 }
817
818 {
819 print "processing facedata...\n" if $VERBOSE;
820 while (my ($k, $v) = each %FACEINFO) {
821 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
822 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
823
824 make_hash $k, $v->{data32}, $v->{hash32};
825 make_hash $k, $v->{data64}, $v->{hash64};
826
827 #length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
828 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
829
830 if (my $magicmap = $v->{magicmap}) {
831 $magicmap =~ y/A-Z_\-/a-z/d;
832 $v->{magicmap} = $COLOR{$magicmap};
833 }
834
835 my $stem = delete $v->{stem};
836 $v->{glyph} //= autoglyph $stem, $v;
837 utf8::encode $v->{glyph};
838 $v->{glyph} = (chr $v->{magicmap}) . $v->{glyph};
839
840 delete $v->{arc};
841 }
842
843 print "processing resources...\n" if $VERBOSE;
844 my $enc = JSON::XS->new->utf8->canonical->relaxed;
845 while (my ($k, $v) = each %RESOURCE) {
846
847 if ($v->{meta} && $v->{meta}{datadir}) {
848 delete $RESOURCE{$k};
849
850 $k =~ s/^res\/// or die "$k: datadir files must be in res/";
851
852 printf "writing $k (%d octets)...\n", length $v->{data} if $VERBOSE;
853 open my $fh, ">:raw", "$DATADIR/$k~"
854 or die "$DATADIR/$k~: $!";
855 syswrite $fh, $v->{data};
856 push @COMMIT, $k;
857
858 } else {
859 if ($v->{type} & 1) {
860 # prepend meta info
861
862 my $meta = $enc->encode ({
863 name => $k,
864 %{ $v->{meta} || {} },
865 });
866
867 $v->{data} = pack "(w/a*)*", $meta, $v->{data};
868 }
869
870 make_hash $k, $v->{data}, $v->{hash}, 6; # 6 for the benefit of existing clients
871 }
872 }
873
874 printf "writing facedata (%d faces, %d anims, %d resources)...\n",
875 scalar keys %FACEINFO,
876 scalar keys %ANIMINFO,
877 scalar keys %RESOURCE
878 if $VERBOSE;
879
293 open my $fh, ">:perlio", "$DATADIR/crossfire.0~" 880 open my $fh, ">:perlio", "$DATADIR/facedata~"
294 or die "$DATADIR/crossfire.0~: $!"; 881 or die "$DATADIR/facedata~: $!";
295 printf $fh "IMAGE %d %d %s\x0a%s", $_, (length $PNG[$_][1]), $PNG[$_][0], $PNG[$_][1] 882
296 for 0.. $#PNG; 883 print $fh nfreeze {
884 version => 2,
885 faceinfo => \%FACEINFO,
886 animinfo => \%ANIMINFO,
887 resource => \%RESOURCE,
297 } 888 };
298 889
299 rename "$DATADIR/archetypes~" , "$DATADIR/archetypes"; 890 }
300 rename "$DATADIR/crossfire.0~", "$DATADIR/crossfire.0";
301 rename "$DATADIR/animations~" , "$DATADIR/animations";
302 891
303 die "--install-arch not fully implemented\n"; 892 print "committing files...\n" if $VERBOSE;
893
894 for (qw(archetypes facedata treasures), @COMMIT) {
895 chmod 0644, "$DATADIR/$_~";
896 rename "$DATADIR/$_~", "$DATADIR/$_"
897 or die "$DATADIR/$_: $!";
898 }
899
900 print "archetype data installed successfully.\n";
304 } 901 }
305} 902}
306 903
307Getopt::Long::Configure ("bundling", "no_ignore_case"); 904Getopt::Long::Configure ("bundling", "no_ignore_case");
308GetOptions ( 905GetOptions (

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines